org.jboss.netty.buffer

## Interface ChannelBufferIndexFinder

    public interface ChannelBufferIndexFinder

Locates an index of data in a `ChannelBuffer`.

This interface enables the sequential search for the data which meets more complex and dynamic condition than just a simple value matching. Please refer to `ChannelBuffer.indexOf(int, int, ChannelBufferIndexFinder)` and `ChannelBuffer.bytesBefore(int, int, ChannelBufferIndexFinder)` for more explanation.

### Field Summary

Fields
`static ChannelBufferIndexFinder` `CR` Index finder which locates a `CR ('\r')` byte.
`static ChannelBufferIndexFinder` `CRLF` Index finder which locates a `CR ('\r')` or `LF ('\n')`.
`static ChannelBufferIndexFinder` `LF` Index finder which locates a `LF ('\n')` byte.
`static ChannelBufferIndexFinder` `LINEAR_WHITESPACE` Index finder which locates a linear whitespace (`' '` and `'\t'`).
`static ChannelBufferIndexFinder` `NOT_CR` Index finder which locates a non-`CR ('\r')` byte.
`static ChannelBufferIndexFinder` `NOT_CRLF` Index finder which locates a byte which is neither a `CR ('\r')` nor a `LF ('\n')`.
`static ChannelBufferIndexFinder` `NOT_LF` Index finder which locates a non-`LF ('\n')` byte.
`static ChannelBufferIndexFinder` `NOT_LINEAR_WHITESPACE` Index finder which locates a byte which is not a linear whitespace (neither `' '` nor `'\t'`).
`static ChannelBufferIndexFinder` `NOT_NUL` Index finder which locates a non-`NUL (0x00)` byte.
`static ChannelBufferIndexFinder` `NUL` Index finder which locates a `NUL (0x00)` byte.

### Method Summary

Methods
`boolean` `find(ChannelBuffer buffer, int guessedIndex)` Returns `true` if and only if the data is found at the specified `guessedIndex` of the specified `buffer`.

### Field Detail

#### NUL

    static final ChannelBufferIndexFinder NUL

Index finder which locates a `NUL (0x00)` byte.

#### NOT_NUL

    static final ChannelBufferIndexFinder NOT_NUL

Index finder which locates a non-`NUL (0x00)` byte.

#### CR

    static final ChannelBufferIndexFinder CR

Index finder which locates a `CR ('\r')` byte.

#### NOT_CR

    static final ChannelBufferIndexFinder NOT_CR

Index finder which locates a non-`CR ('\r')` byte.

#### LF

    static final ChannelBufferIndexFinder LF

Index finder which locates a `LF ('\n')` byte.

#### NOT_LF

    static final ChannelBufferIndexFinder NOT_LF

Index finder which locates a non-`LF ('\n')` byte.

#### CRLF

    static final ChannelBufferIndexFinder CRLF

Index finder which locates a `CR ('\r')` or `LF ('\n')`.

#### NOT_CRLF

    static final ChannelBufferIndexFinder NOT_CRLF

Index finder which locates a byte which is neither a `CR ('\r')` nor a `LF ('\n')`.

#### LINEAR_WHITESPACE

    static final ChannelBufferIndexFinder LINEAR_WHITESPACE

Index finder which locates a linear whitespace (`' '` and `'\t'`).

#### NOT_LINEAR_WHITESPACE

    static final ChannelBufferIndexFinder NOT_LINEAR_WHITESPACE

Index finder which locates a byte which is not a linear whitespace (neither `' '` nor `'\t'`).

### Method Detail

#### find

    boolean find(ChannelBuffer buffer,
               int guessedIndex)

Returns `true` if and only if the data is found at the specified `guessedIndex` of the specified `buffer`.

The implementation should not perform an operation which raises an exception such as `IndexOutOfBoundsException` nor perform an operation which modifies the content of the buffer.